/**
 * @file
 * VuoList_VuoBlendMode C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoBlendMode_H
#define VuoList_VuoBlendMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoBlendMode VuoList_VuoBlendMode
 * A list of @ref VuoBlendMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoBlendMode
 * A list of @ref VuoBlendMode elements.
 */
#ifndef VuoList_VuoBlendMode_TYPE_DEFINED
typedef void * VuoList_VuoBlendMode;
#endif

/**
 * Creates a new list of @ref VuoBlendMode elements.
 */
VuoList_VuoBlendMode VuoListCreate_VuoBlendMode(void);

/**
 * Returns the @ref VuoBlendMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoBlendMode VuoListGetValueAtIndex_VuoBlendMode(const VuoList_VuoBlendMode list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoBlendMode(VuoList_VuoBlendMode list, const VuoBlendMode value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoBlendMode(VuoList_VuoBlendMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoBlendMode(VuoList_VuoBlendMode list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoBlendMode(const VuoList_VuoBlendMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoBlendMode VuoList_VuoBlendMode_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoBlendMode_jsonFromValue(const VuoList_VuoBlendMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoBlendMode_summaryFromValue(const VuoList_VuoBlendMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoBlendMode VuoList_VuoBlendMode_valueFromString(const char *str);
char * VuoList_VuoBlendMode_stringFromValue(const VuoList_VuoBlendMode value);
/// @}

/**
 * @}
 */

#endif
