/**
 * @file
 * VuoList_VuoGradientNoise C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoGradientNoise_H
#define VuoList_VuoGradientNoise_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoGradientNoise VuoList_VuoGradientNoise
 * A list of @ref VuoGradientNoise elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoGradientNoise
 * A list of @ref VuoGradientNoise elements.
 */
#ifndef VuoList_VuoGradientNoise_TYPE_DEFINED
typedef void * VuoList_VuoGradientNoise;
#endif

/**
 * Creates a new list of @ref VuoGradientNoise elements.
 */
VuoList_VuoGradientNoise VuoListCreate_VuoGradientNoise(void);

/**
 * Returns the @ref VuoGradientNoise at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoGradientNoise VuoListGetValueAtIndex_VuoGradientNoise(const VuoList_VuoGradientNoise list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoGradientNoise(VuoList_VuoGradientNoise list, const VuoGradientNoise value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoGradientNoise(VuoList_VuoGradientNoise list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoGradientNoise(VuoList_VuoGradientNoise list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoGradientNoise(const VuoList_VuoGradientNoise list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoGradientNoise VuoList_VuoGradientNoise_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoGradientNoise_jsonFromValue(const VuoList_VuoGradientNoise value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoGradientNoise_summaryFromValue(const VuoList_VuoGradientNoise value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoGradientNoise VuoList_VuoGradientNoise_valueFromString(const char *str);
char * VuoList_VuoGradientNoise_stringFromValue(const VuoList_VuoGradientNoise value);
/// @}

/**
 * @}
 */

#endif
