/**
 * @file
 * VuoList_VuoMouseButtonAction C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMouseButtonAction_H
#define VuoList_VuoMouseButtonAction_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMouseButtonAction VuoList_VuoMouseButtonAction
 * A list of @ref VuoMouseButtonAction elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoMouseButtonAction
 * A list of @ref VuoMouseButtonAction elements.
 */
#ifndef VuoList_VuoMouseButtonAction_TYPE_DEFINED
typedef void * VuoList_VuoMouseButtonAction;
#endif

/**
 * Creates a new list of @ref VuoMouseButtonAction elements.
 */
VuoList_VuoMouseButtonAction VuoListCreate_VuoMouseButtonAction(void);

/**
 * Returns the @ref VuoMouseButtonAction at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMouseButtonAction VuoListGetValueAtIndex_VuoMouseButtonAction(const VuoList_VuoMouseButtonAction list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMouseButtonAction(VuoList_VuoMouseButtonAction list, const VuoMouseButtonAction value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMouseButtonAction(VuoList_VuoMouseButtonAction list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMouseButtonAction(VuoList_VuoMouseButtonAction list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMouseButtonAction(const VuoList_VuoMouseButtonAction list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMouseButtonAction VuoList_VuoMouseButtonAction_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMouseButtonAction_jsonFromValue(const VuoList_VuoMouseButtonAction value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMouseButtonAction_summaryFromValue(const VuoList_VuoMouseButtonAction value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMouseButtonAction VuoList_VuoMouseButtonAction_valueFromString(const char *str);
char * VuoList_VuoMouseButtonAction_stringFromValue(const VuoList_VuoMouseButtonAction value);
/// @}

/**
 * @}
 */

#endif
