/**
 * @file
 * VuoList_VuoSyphonServerDescription C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoSyphonServerDescription_H
#define VuoList_VuoSyphonServerDescription_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription
 * A list of @ref VuoSyphonServerDescription elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoSyphonServerDescription
 * A list of @ref VuoSyphonServerDescription elements.
 */
#ifndef VuoList_VuoSyphonServerDescription_TYPE_DEFINED
typedef void * VuoList_VuoSyphonServerDescription;
#endif

/**
 * Creates a new list of @ref VuoSyphonServerDescription elements.
 */
VuoList_VuoSyphonServerDescription VuoListCreate_VuoSyphonServerDescription(void);

/**
 * Returns the @ref VuoSyphonServerDescription at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoSyphonServerDescription VuoListGetValueAtIndex_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const VuoSyphonServerDescription value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoSyphonServerDescription_jsonFromValue(const VuoList_VuoSyphonServerDescription value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoSyphonServerDescription_summaryFromValue(const VuoList_VuoSyphonServerDescription value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription_valueFromString(const char *str);
char * VuoList_VuoSyphonServerDescription_stringFromValue(const VuoList_VuoSyphonServerDescription value);
/// @}

/**
 * @}
 */

#endif
